<?php
namespace Plugin\DBMS;

class Interaction {
	
	protected $table_name;
	protected $table_id;
	
	private $connection;
	
	protected function getManager(){
		return Manager::getManager();
	}
	
	protected  function simplyQuery($sql){
		return $this->getManager()->rawQuery($sql);
	}
	
	protected function escape($string){
		return $this->getManager()->getConnection()->real_escape_string($string);
	}
	
	public function find($id){
		$sql = "SELECT * FROM `{$this->table_name}` 
		WHERE `{$this->table_id}` =  ".((int) $id);
		$result = $this->simplyQuery($sql);
		return $result && isset($result[0])? $result[0]:false;
	}
	
	
}