<?php
namespace src\Blog\Model\Services;

use Plugin\Controller\Container;
class Authentication extends Container {
	
	public function __construct(){
		//echo "I am the authenticator";
	}
	
	public function isAuthorized(){
		
		//$sess = $this->get("session");
		$realm = 'Restricted area2';
		$users = array('scratchuser' => '!bigcomplicatedpass2');
			
		if (empty($_SERVER['PHP_AUTH_DIGEST'])) {
			$this->throwUnauthorized($realm);
			echo "Not Authorized!";
			exit;
			return false;
		}
			
		// analyze the PHP_AUTH_DIGEST variable
		if (!($data = $this->http_digest_parse($_SERVER['PHP_AUTH_DIGEST'])) ||
			!isset($users[$data['username']])) {
			sleep(2);
			die('Wrong Credentials!');
		}
				
		// generate the valid response
		$A1 = md5($data['username'] . ':' . $realm . ':' . $users[$data['username']]);
		$A2 = md5($_SERVER['REQUEST_METHOD'].':'.$data['uri']);
		$valid_response = md5($A1.':'.$data['nonce'].':'.$data['nc'].':'.$data['cnonce'].':'.$data['qop'].':'.$A2);
			
		if ($data['response'] != $valid_response){
			die('Wrong Credentials!');
		}
		return true;
	}
	
	public function gotoLogin(){
		$req = $this->getRequest();
		$url = $req->generateUrl("AdminLogin");
		$req->redirectToUrl($url);
	}
	
	
	private function http_digest_parse($txt){
		// protect against missing data
		$needed_parts = array('nonce'=>1, 'nc'=>1, 'cnonce'=>1, 'qop'=>1, 'username'=>1, 'uri'=>1, 'response'=>1);
		$data = array();
		$keys = implode('|', array_keys($needed_parts));
	
		preg_match_all('@(' . $keys . ')=(?:([\'"])([^\2]+?)\2|([^\s,]+))@', $txt, $matches, PREG_SET_ORDER);
	
		foreach ($matches as $m) {
			$data[$m[1]] = $m[3] ? $m[3] : $m[4];
			unset($needed_parts[$m[1]]);
		}
	
		return $needed_parts ? false : $data;
	}
	
	public function throwUnauthorized($realm){
		header('HTTP/1.1 401 Unauthorized');
		header('WWW-Authenticate: Digest realm="'.$realm.
		'",qop="auth",nonce="'.uniqid().'",opaque="'.md5($realm).'"');
	
		exit;
	}
}